package arm

import "git.urbach.dev/cli/q/src/cpu"

// AddRegisterNumber adds a number to a register.
func AddRegisterNumber(destination cpu.Register, source cpu.Register, number int) uint32 {
	return addRegisterNumber(destination, source, number, 0)
}

// AddRegisterRegister adds a register to a register.
func AddRegisterRegister(destination cpu.Register, source cpu.Register, operand cpu.Register) uint32 {
	return addRegisterRegister(destination, source, operand, 0)
}

// addRegisterNumber adds the register and optionally updates the condition flags based on the result.
func addRegisterNumber(destination cpu.Register, source cpu.Register, number int, flags uint32) uint32 {
	return flags<<29 | 0b100100010<<23 | reg2Imm(destination, source, number)
}

// addRegisterRegister adds the registers and optionally updates the condition flags based on the result.
func addRegisterRegister(destination cpu.Register, source cpu.Register, operand cpu.Register, flags uint32) uint32 {
	return flags<<29 | 0b10001011000<<21 | reg3(destination, source, operand)
}
